
package com.topcoder.message.im;
import com.topcoder.message.im.MessageProcessor;
import java.util.*;

/**
 * <p>A simple implementation of MessageProcessor that comes with the first release of the Instant Messaging component. It uses a linked list to simulate a message queue. All operations should be synchronized.</p>
 * 
 */
public class MessageQueue {

/**
 * <p>The linked list that acts as a FIFO container. It is initialized directly but the content is mutable. All operations should synchronize on it. It is manipulated in vairous methods.</p>
 * 
 */
    private java.util.List queue = new LinkedList();

/**
 * <p>Creates a message queue. Does nothing.</p>
 * 
 * 
 * 
 */
    public  MessageQueue() {        
        // your code here
    } 

/**
 * <p>Process the message. Simply add the message to the tail of the linked list.</p>
 * 
 * 
 * 
 * 
 * @param message the message to process
 * @exception NullPointerException if message is null
 */
    public void processMessage(com.topcoder.message.im.Message message) {        
        // your code here
    } 

/**
 * <p>Peek the top of the queue. It returns the message on the head of the linked list without consuming it. If the queue is empty simply return null.</p>
 * 
 * 
 * 
 * 
 * @return the top message or null if queue is empty
 */
    public com.topcoder.message.im.Message peekMessage() {        
        // your code here
        return null;
    } 

/**
 * <p>Get the first message and remove it from the queue. If the queue is empty return null.</p>
 * 
 * 
 * 
 * 
 * @return the first message in the queue
 */
    public com.topcoder.message.im.Message fecthMessage() {        
        // your code here
        return null;
    } 

/**
 * <p>Get the size of the queue (number of messages waiting to be handled).</p>
 * 
 * 
 * 
 * 
 * @return the size of the message queue
 */
    public int getQueueSize() {        
        // your code here
        return 0;
    } 

/**
 * <p>Drop all the messages in the queue.</p>
 * 
 * 
 * 
 */
    public void clearQueue() {        
        // your code here
    } 
 }
